# http://doc.gitlab.com/ce/ci/yaml/README.html
# https://docs.gitlab.com/ce/ci/variables/README.html
# https://docs.gitlab.com/ce/ci/docker/using_docker_build.html#use-docker-in-docker-executor

image: docker:latest

variables:
  DOCKER_HOST: tcp://docker:2375
  # When using dind (docker-in-docker), it's wise to use the overlayfs driver for improved performance.
  DOCKER_DRIVER: overlay2
  # tag naming
  TAG_FINAL: latest
  TAG_PREFIX: ${CI_COMMIT_REF_NAME%master}

services:
  - docker:dind

stages:
  - build
  - release

before_script:
  - echo "${CI_JOB_TOKEN}" | docker login --username gitlab-ci-token --password-stdin "${CI_REGISTRY}"
  - if [[ -n "${DOCKER_USERNAME}" ]]; then echo "${DOCKER_PASSWORD}" | docker login --username "${DOCKER_USERNAME}" --password-stdin docker.io; fi

build:
  stage: build
  script:
    - ./build.sh --build=Dockerfile "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --push "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"

release:
  stage: release
  dependencies:
    - build
  only:
    - master
  script:
    - ./build.sh --pull "${CI_REGISTRY_IMAGE}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --tag "${CI_REGISTRY_IMAGE}${DOCKER_REPOS:+ ${DOCKER_REPOS}}${DOCKER_USERNAME:+ docker.io/${DOCKER_USERNAME}/${CI_PROJECT_NAME#docker-}}" "${TAG_FINAL}" "${TAG_PREFIX}"
    - ./build.sh --push "${CI_REGISTRY_IMAGE}${DOCKER_REPOS:+ ${DOCKER_REPOS}}${DOCKER_USERNAME:+ docker.io/${DOCKER_USERNAME}/${CI_PROJECT_NAME#docker-}}" "${TAG_FINAL}" "${TAG_PREFIX}"
